library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity HPTDC_Tester_Top is
    Port ( -- Signals directions are reference from HPTDC (i.e serial_out mean serial data OUT from HPTDC and INTO the FPGA)

-- HPTDC Signals:
			   
		-- HPTDC reset
	 		  reset 				: out std_logic;	  	-- master reset the HPTDC
			  bunch_reset 		: out std_logic;
			  event_reset 		: out std_logic;
		--	HPTDC Clock
			  aux_clock 		: out std_logic;           
           HPTDC_CLK2 		: out std_logic;
			  FPGA_CLK 			: out std_logic;
                     
		-- HPTDC Serial data 			             
           serial_bypass_in : out std_logic;
           serial_in 		: out std_logic;
           serial_out 		: in std_logic;
			  serial_out_TTL 	: in std_logic;
           strobe_out 		: in std_logic;
			  strobe_out_TTL 	: in std_logic;
		-- HPTDC Token signals
           token_bypass_in : out std_logic;
           token_in 			: out std_logic;
           token_out 		: in std_logic;
			  token_out_TTL 	: in std_logic;

           trigger 			: out std_logic;
           Par_data_out 	: in std_logic_vector(31 downto 0);
           data_ready 		: in std_logic;
           error 				: in std_logic;      -- Indicate that the HPTDC is in error mode                         
           test 				: in std_logic;           
           get_data 			: out std_logic;		-- 
			  encoded_control : out std_logic;
-- Other signals:
			  Par_data_out_clk : out std_logic; 	-- used to latch the Parallel data into L.A
           Output_clk 		: out std_logic;
			  FE_Test_Pulse 	: out std_logic;
			  Board_reset     : in std_logic;
--	JTAG signals to program the TDC from FPGA
			  FPGA_TDC_TMS		: in std_logic;
           FPGA_TDC_TCK 	: in std_logic;
           FPGA_TDC_TDO 	: out std_logic;
           FPGA_TDC_TDI 	: in std_logic;
--	Data to/from DIO-96
           FPGA_data_out 	: out std_logic_vector(31 downto 0);
           PC_Control_in 	: in std_logic_vector(7 downto 0);
           Spare 				: inout std_logic_vector(7 downto 0));
end HPTDC_Tester_Top;

architecture Behavioral of HPTDC_Tester_Top is

begin


end Behavioral;
